Installing AWS infrastructure through Terraform scripts
==============================================================================

This file explains how to set up the expected infrastructure awaited to implement the JSON API.
The installation is based on Terraform (https://www.terraform.io/)

It expects that by AWS CLI and Terraform have previously been installed and set up correctly. 
The AWS Credentials should also have been set up 

How it works
------------------------------------------------------------------------------
AWS JSON API server relies on 3 main components, plus the needed IAM roles :
- A DynamoDB table manipuling all serialized objects
- A lambda function in charge of the translation from JSON API format to dynamoDB objects and managing the relationships and the optional parameters provided in the request
- An API Gateway configured to received the REST HTTP requests and proxying the Lambda

Three Terraform files are available, each one created the needed component and their relationships with each other.

Installation
------------------------------------------------------------------------------

The lambda code needs to be stored in a S3 bucket before running the Terraform scripts.
The script is available in the cloud/lambda directory of this project.
The following operations need to be performed (adapting the region you are using):

```
zip lambda-jsonapi.zip ../lambda/lambda-jsonapi.js
aws s3api create-bucket --bucket=lambda-jsonapi-bucket --region=us-east-1
aws s3 cp lambda-jsonapi-bucket.zip s3://lambda-jsonapi-bucket/v1.0.0/lambda-jsonapi-bucket.zip
```
One this is done, simply run the terraform script :
```
terraform apply
```
For a strange reason I don't understand, the first time you run the terraform command, the mapping for the integration response fails. You have to run the command again to have your complete setup.